#ifndef PRINT_BUFFER_SIZE

#define PRINT_BUFFER_SIZE 512

#define HBA_FLAGS_DBG_FLAGS_MASK 	0x0000ffff
#define HBA_FLAGS_DBG_KERNEL_PRINT_B 	0x00000001
#define HBA_FLAGS_DBG_FW_PRINT_B 	0x00000002
#define HBA_FLAGS_DBG_FUNCTION_ENTRY_B 	0x00000004
#define HBA_FLAGS_DBG_FUNCTION_EXIT_B 	0x00000008
#define HBA_FLAGS_DBG_ERROR_B 		0x00000010
#define HBA_FLAGS_DBG_INIT_B 		0x00000020
#define HBA_FLAGS_DBG_OS_COMMANDS_B 	0x00000040
#define HBA_FLAGS_DBG_SCAN_B 		0x00000080
#define HBA_FLAGS_DBG_COALESCE_B 	0x00000100
#define HBA_FLAGS_DBG_IOCTL_COMMANDS_B 	0x00000200
#define HBA_FLAGS_DBG_SYNC_COMMANDS_B 	0x00000400
#define HBA_FLAGS_DBG_COMM_B 		0x00000800
#define HBA_FLAGS_DBG_CSMI_COMMANDS_B 	0x00001000
#define HBA_FLAGS_DBG_AIF_B 		0x00001000

#define FW_DEBUG_STR_LENGTH_OFFSET 	0x00
#define FW_DEBUG_FLAGS_OFFSET 		0x04
#define FW_DEBUG_BLED_OFFSET 		0x08
#define FW_DEBUG_FLAGS_NO_HEADERS_B 	0x01

struct aac_softc;
extern int aac_get_fw_debug_buffer(struct aac_softc *);
extern void aac_fw_printf(struct aac_softc *, unsigned long, const char *, ...);
extern void aac_fw_print_mem(struct aac_softc *, unsigned long, u_int8_t *,int);
extern int aac_sync_command(struct aac_softc *sc, u_int32_t command,
				 u_int32_t arg0, u_int32_t arg1, u_int32_t arg2,
				 u_int32_t arg3, u_int32_t *sp, u_int32_t *r1);

#endif
